blob: 4c1e710d2b2784d79bae4737d95d758920113a8d [file] [log] [blame]
Erwan Veluafbbd642013-06-25 17:47:01 +02001#!/bin/bash
2#
3# Copyright (C) 2013 eNovance SAS <licensing@enovance.com>
4# Author: Erwan Velu <erwan@enovance.com>
5#
6# The license below covers all files distributed with fio unless otherwise
7# noted in the file itself.
8#
9# This program is free software; you can redistribute it and/or modify
10# it under the terms of the GNU General Public License version 2 as
11# published by the Free Software Foundation.
12#
13# This program is distributed in the hope that it will be useful,
14# but WITHOUT ANY WARRANTY; without even the implied warranty of
15# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
16# GNU General Public License for more details.
17#
18# You should have received a copy of the GNU General Public License
19# along with this program; if not, write to the Free Software
20# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
21
22BLK_SIZE=
23BLOCK_SIZE=4k
24SEQ=-1
25TEMPLATE=/tmp/template.fio
26OUTFILE=
27DISKS=
28RUNTIME=300
29ETA=0
Erwan Velu60238f02013-07-12 15:21:25 +020030MODES="write,randwrite,read,randread"
Erwan Veluafbbd642013-06-25 17:47:01 +020031SHORT_HOSTNAME=
Erwan Velu76c7c632013-07-10 16:44:24 +020032CACHED_IO="FALSE"
Erwan Velua7419832013-07-11 09:56:28 +020033PREFIX=""
34PREFIX_FILENAME=""
Erwan Velu7d1ca6c2013-07-12 17:01:31 +020035IODEPTH=1
Erwan Veluafbbd642013-06-25 17:47:01 +020036
37show_help() {
38 PROG=$(basename $0)
39 echo "usage of $PROG:"
40 cat << EOF
41-h : Show this help & exit
Erwan Velu76c7c632013-07-10 16:44:24 +020042-c : Enable cached-based IOs
Erwan Velue1c6f2e2013-07-10 16:50:20 +020043 Disabled by default
Erwan Veluafbbd642013-06-25 17:47:01 +020044-a : Run sequential test then parallel one
Erwan Velue1c6f2e2013-07-10 16:50:20 +020045 Disabled by default
Erwan Veluafbbd642013-06-25 17:47:01 +020046-s : Run sequential test (default value)
47 one test after another then one disk after another
Erwan Velue1c6f2e2013-07-10 16:50:20 +020048 Disabled by default
Erwan Veluafbbd642013-06-25 17:47:01 +020049-p : Run parallel test
50 one test after anoter but all disks at the same time
Erwan Velue1c6f2e2013-07-10 16:50:20 +020051 Enabled by default
Erwan Velu7d1ca6c2013-07-12 17:01:31 +020052-D iodepth : Run with the specified iodepth
53 Default is 32
Erwan Veluafbbd642013-06-25 17:47:01 +020054-d disk1[,disk2,disk3,..] : Run the tests on the selected disks
55 Separated each disk with a comma
56 Disk name shall be "sdxx", /dev/ shall NOT be used here
Erwan Velue1c6f2e2013-07-10 16:50:20 +020057-r seconds : Time in seconds per benchmark
Erwan Velu72fe3ef2013-07-10 16:38:33 +020058 0 means till the end of the device
Erwan Velue1c6f2e2013-07-10 16:50:20 +020059 Default is 300 seconds
Erwan Veluafbbd642013-06-25 17:47:01 +020060-b blocksize[,blocksize1, ...] : The blocksizes to test under fio format (4k, 1m, ...)
61 Separated each blocksize with a comma
Erwan Velue1c6f2e2013-07-10 16:50:20 +020062 Default is 4k
Erwan Veluafbbd642013-06-25 17:47:01 +020063-m mode1,[mode2,mode3, ...] : Define the fio IO profile to use like read, write, randread, randwrite
Erwan Velu60238f02013-07-12 15:21:25 +020064 Default is "write,randwrite,read,randread"
Erwan Velua7419832013-07-11 09:56:28 +020065-x prefix : Add a prefix to the fio filename
66 Useful to let a context associated with the file
67 If the prefix features a / (slash), prefix will be considered as a directory
Erwan Veluafbbd642013-06-25 17:47:01 +020068
69Example:
70
Erwan Velua7419832013-07-11 09:56:28 +020071$PROG -d sdb,sdc,sdd,sde -a -b 4k,128k,1m -r 100 -a -x dellr720-day2/
Erwan Veluafbbd642013-06-25 17:47:01 +020072
73 Will generate an fio file that will run
Erwan Velu60238f02013-07-12 15:21:25 +020074 - a sequential bench on /dev/sdb /dev/sdc /dev/sdd /dev/sde for block size = 4k with write,randwrite,read,randread tests
Erwan Veluafbbd642013-06-25 17:47:01 +020075 ETA ~ 4 tests * 4 disks * 100 seconds
Erwan Velu60238f02013-07-12 15:21:25 +020076 - a sequential bench on /dev/sdb /dev/sdc /dev/sdd /dev/sde for block size = 128k with write,randwrite,read,randread tests
Erwan Veluafbbd642013-06-25 17:47:01 +020077 ETA ~ 4 tests * 4 disks * 100 seconds
Erwan Velu60238f02013-07-12 15:21:25 +020078 - a sequential bench on /dev/sdb /dev/sdc /dev/sdd /dev/sde for block size = 1m with write,randwrite,read,randread tests
Erwan Veluafbbd642013-06-25 17:47:01 +020079 ETA ~ 4 tests * 4 disks * 100 seconds
Erwan Velu60238f02013-07-12 15:21:25 +020080 - a parallel bench on /dev/sdb /dev/sdc /dev/sdd /dev/sde for block size = 4k with write,randwrite,read,randread tests
Erwan Veluafbbd642013-06-25 17:47:01 +020081 ETA ~ 4 tests * 100 seconds
Erwan Velu60238f02013-07-12 15:21:25 +020082 - a parallel bench on /dev/sdb /dev/sdc /dev/sdd /dev/sde for block size = 128k with write,randwrite,read,randread tests
Erwan Veluafbbd642013-06-25 17:47:01 +020083 ETA ~ 4 tests * 100 seconds
Erwan Velu60238f02013-07-12 15:21:25 +020084 - a parallel bench on /dev/sdb /dev/sdc /dev/sdd /dev/sde for block size = 1m with write,randwrite,read,randread tests
Erwan Veluafbbd642013-06-25 17:47:01 +020085 ETA ~ 4 tests * 100 seconds
86
Erwan Velu60238f02013-07-12 15:21:25 +020087Generating dellr720-day2/localhost-4k,128k,1m-all-write,randwrite,read,randread-sdb,sdc,sdd,sde.fio
Erwan Veluafbbd642013-06-25 17:47:01 +020088Estimated Time = 6000 seconds : 1 hour 40 minutes
89EOF
90}
91
92gen_template() {
93cat >$TEMPLATE << EOF
94[global]
95ioengine=libaio
Erwan Velu7d1ca6c2013-07-12 17:01:31 +020096iodepth=$IODEPTH
Erwan Veluafbbd642013-06-25 17:47:01 +020097invalidate=1
Erwan Veluafbbd642013-06-25 17:47:01 +020098ramp_time=5
Erwan Veluafbbd642013-06-25 17:47:01 +020099EOF
Erwan Velu72fe3ef2013-07-10 16:38:33 +0200100
101if [ "$RUNTIME" != "0" ]; then
102cat >>$TEMPLATE << EOF
103runtime=$RUNTIME
104EOF
105fi
106
Erwan Velu76c7c632013-07-10 16:44:24 +0200107if [ "$CACHED_IO" = "FALSE" ]; then
108cat >>$TEMPLATE << EOF
109direct=1
110EOF
111fi
112
Erwan Veluafbbd642013-06-25 17:47:01 +0200113}
114
115gen_seq_suite() {
116TYPE=$1
117cat >> $OUTFILE << EOF
118[$TYPE-$disk-$BLK_SIZE-seq]
119stonewall
120bs=$BLK_SIZE
121filename=/dev/$disk
122rw=$TYPE
Erwan Velua7419832013-07-11 09:56:28 +0200123write_bw_log=${PREFIX_FILENAME}$SHORT_HOSTNAME-$BLK_SIZE-$disk-$TYPE-seq.results
124write_iops_log=${PREFIX_FILENAME}$SHORT_HOSTNAME-$BLK_SIZE-$disk-$TYPE-seq.results
Erwan Veluafbbd642013-06-25 17:47:01 +0200125EOF
126ETA=$(($ETA + $RUNTIME))
127}
128
129gen_seq_fio() {
130for disk in $(echo $DISKS | tr "," " "); do
131 for mode in $(echo $MODES | tr "," " "); do
132 gen_seq_suite "$mode"
133 done
134done
135}
136
137
138gen_para_suite() {
139TYPE=$1
140NEED_WALL=$2
141D=0
142for disk in $(echo $DISKS | tr "," " "); do
143 cat >> $OUTFILE << EOF
144[$TYPE-$disk-$BLK_SIZE-para]
145bs=$BLK_SIZE
146EOF
147
148if [ "$D" = 0 ]; then
149 echo "stonewall" >> $OUTFILE
150 D=1
151fi
152
153cat >> $OUTFILE << EOF
154filename=/dev/$disk
155rw=$TYPE
Erwan Velua7419832013-07-11 09:56:28 +0200156write_bw_log=${PREFIX_FILENAME}$SHORT_HOSTNAME-$BLK_SIZE-$disk-$TYPE-para.results
157write_iops_log=${PREFIX_FILENAME}$SHORT_HOSTNAME-$BLK_SIZE-$disk-$TYPE-para.results
Erwan Veluafbbd642013-06-25 17:47:01 +0200158EOF
159done
160
161ETA=$(($ETA + $RUNTIME))
162echo >> $OUTFILE
163}
164
165gen_para_fio() {
166for mode in $(echo $MODES | tr "," " "); do
167 gen_para_suite "$mode"
168done
169}
170
171gen_fio() {
172case $SEQ in
173 2)
174 gen_seq_fio
175 gen_para_fio
176 ;;
177 1)
178 gen_seq_fio
179 ;;
180 0)
181 gen_para_fio
182 ;;
183esac
184}
185
186parse_cmdline() {
Erwan Velu7d1ca6c2013-07-12 17:01:31 +0200187while getopts "hacpsd:b:r:m:x:D:" opt; do
Erwan Veluafbbd642013-06-25 17:47:01 +0200188 case $opt in
189 h)
190 show_help
191 exit 0
192 ;;
193 b)
194 BLOCK_SIZE=$OPTARG
195 ;;
Erwan Velu76c7c632013-07-10 16:44:24 +0200196 c)
197 CACHED_IO="TRUE"
198 ;;
Erwan Veluafbbd642013-06-25 17:47:01 +0200199 s)
200 if [ "$SEQ" = "-1" ]; then
201 SEQ=1
202 fi
203 ;;
Erwan Velua7419832013-07-11 09:56:28 +0200204 x)
205 PREFIX=$OPTARG
206 echo "$PREFIX" | grep -q "/"
207 if [ "$?" -eq 0 ]; then
208 mkdir -p $PREFIX
209 # No need to keep the prefix for the log files
210 # we do have a directory for that
211 PREFIX_FILENAME=""
212 else
213 # We need to keep the prefix for the log files
214 PREFIX_FILENAME=$PREFIX
215 fi
216 ;;
Erwan Veluafbbd642013-06-25 17:47:01 +0200217 r)
218 RUNTIME=$OPTARG
219 ;;
220 p)
221 if [ "$SEQ" = "-1" ]; then
222 SEQ=0
223 fi
224 ;;
225 m)
226 MODES=$OPTARG;
227 ;;
228 d)
229 DISKS=$OPTARG
230 ;;
Erwan Velu7d1ca6c2013-07-12 17:01:31 +0200231 D)
232 IODEPTH=$OPTARG
233 ;;
Erwan Veluafbbd642013-06-25 17:47:01 +0200234 a)
235 SEQ=2
236 ;;
237 \?)
238 echo "Invalid option: -$OPTARG" >&2
239 ;;
240 esac
241done
242
243if [ "$SEQ" = "-1" ]; then
244 SEQ=0
245fi
246
247SHORT_HOSTNAME=$(hostname -s)
248case $SEQ in
249 2)
Erwan Velua7419832013-07-11 09:56:28 +0200250 OUTFILE=${PREFIX}$SHORT_HOSTNAME-$BLOCK_SIZE-all-$MODES-$DISKS.fio
Erwan Veluafbbd642013-06-25 17:47:01 +0200251 ;;
252
253 1)
Erwan Velua7419832013-07-11 09:56:28 +0200254 OUTFILE=${PREFIX}$SHORT_HOSTNAME-$BLOCK_SIZE-sequential-$MODES-$DISKS.fio
Erwan Veluafbbd642013-06-25 17:47:01 +0200255 ;;
256 0)
Erwan Velua7419832013-07-11 09:56:28 +0200257 OUTFILE=${PREFIX}$SHORT_HOSTNAME-$BLOCK_SIZE-parallel-$MODES-$DISKS.fio
Erwan Veluafbbd642013-06-25 17:47:01 +0200258 ;;
259esac
260
261if [ -z "$DISKS" ]; then
262 echo "Missing DISKS !"
Erwan Velue1c6f2e2013-07-10 16:50:20 +0200263 echo "Please read the help !"
264 show_help
Erwan Veluafbbd642013-06-25 17:47:01 +0200265 exit 1
266fi
267
268}
269
Erwan Velu60238f02013-07-12 15:21:25 +0200270check_mode_order() {
271FOUND_WRITE="NO"
272CAUSE="You are reading data before writing them "
273
274# If no write occurs, let's show a different message
275echo $MODES | grep -q "write"
276if [ "$?" -ne 0 ]; then
277 CAUSE="You are reading data while never wrote them before"
278fi
279
280for mode in $(echo $MODES | tr "," " "); do
281 echo $mode | grep -q write
282 if [ "$?" -eq 0 ]; then
283 FOUND_WRITE="YES"
284 fi
285 echo $mode | grep -q "read"
286 if [ "$?" -eq 0 ]; then
287 if [ "$FOUND_WRITE" = "NO" ]; then
288 echo "###############################################################"
289 echo "# Warning : $CAUSE#"
290 echo "# On some storage devices, this could lead to invalid results #"
291 echo "# #"
292 echo "# Press Ctrl-C to adjust pattern order if you have doubts #"
293 echo "# Or Wait 5 seconds before the file will be created #"
294 echo "###############################################################"
295 sleep 5
296 # No need to try showing the message more than one time
297 return
298 fi
299 fi
300done
301}
302
Erwan Veluafbbd642013-06-25 17:47:01 +0200303
304########## MAIN
305parse_cmdline $@
Erwan Velu60238f02013-07-12 15:21:25 +0200306check_mode_order
Erwan Veluafbbd642013-06-25 17:47:01 +0200307gen_template
308
309echo "Generating $OUTFILE"
310cp -f $TEMPLATE $OUTFILE
311echo >> $OUTFILE
312
313for BLK_SIZE in $(echo $BLOCK_SIZE | tr "," " "); do
314 gen_fio
315done
316ETA_H=$(($ETA / 3600))
317ETA_M=$((($ETA - ($ETA_H*3600)) / 60))
Erwan Veluaf360e32013-07-11 10:16:05 +0200318if [ "$ETA" = "0" ]; then
Erwan Velu72fe3ef2013-07-10 16:38:33 +0200319 echo "Cannot estimate ETA as RUNTIME=0"
320else
321 echo "Estimated Time = $ETA seconds : $ETA_H hour $ETA_M minutes"
322fi